#!/usr/local/bin/perl
#======================================
# Dies\bfh
#--------------------------------------
#======================================
#======================================

	if ($ENV{'REQUEST_METHOD'} eq "GET") {
		$buf = $ENV{'QUERY_STRING'};
	} elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
		if ($ENV{'CONTENT_LENGTH'} > 0) {
			read(STDIN, $buf, $ENV{'CONTENT_LENGTH'});
		} else {
			$buf = '';
		}
	}
	@PAIRS = split(/&/, $buf);
	if (@PAIRS > 0) {
		foreach (@PAIRS) {
			($name, $value) = split(/=/, $_);
			$name =~ tr/+/ /;
			$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
			$value =~ tr/+/ /;
			$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
			$QUERY{$name} = $value;
		}
	}
	$use_org_random = 1;

	&put_anime_dies;

exit;

sub put_anime_dies {

	local (@PAL);
	local ($w, $h);
	local ($loop);
	local (@VALS);
	local (@QVALS);
	local ($len);
	local ($i, $j);
	local ($c);

	$w = 16;
	$h = 16;

	if ($QUERY{'s'} ne '') {
		&random_seed($QUERY{'s'});
	} else {
		&random_seed('');
	}

	$loop = 8;
	if ($QUERY{'n'} ne '') {
		$loop = $QUERY{'n'};
		if ($loop > 100) {
			$loop = 100;
		}
	}
	@QVALS = ();
	if ($QUERY{'v'} ne '') {
		$len = length($QUERY{'v'});
		for ($i = 0; $i < $len; $i++) {
			$c = substr($QUERY{'v'}, $i, 1);
			if ($c =~ /^[1-6]$/) {
				$QVALS[$i] = $c;
			} else {
				$QVALS[$i] = 0;
			}
		}
		if (@QVALS > 0) {
			$loop--;
		}
	}

	binmode(STDOUT);
	print "Content-type: image/gif\n\n";

	$len = @QVALS;
	if ($len <= 0) {
		if ($QUERY{'l'} > 0) {
			$len = $QUERY{'l'};
		} else {
			$len = 3;
		}
	}
	&put_header_blk(5, $w * $len, $h);

	@PAL = &get_dies_palette(1);
	&put_palette_blk(*PAL);

	for ($i = 0; $i < $loop; $i++) {
		@VALS = ();
		for ($j = 0; $j < $len; $j++) {
			$VALS[$j] = int(&get_random_value(6)) + 1;
		}
		&put_anime_frame(*VALS, 0, 0, $w, $h);
	}

	if (@QVALS > 0) {
		&put_anime_frame(*QVALS, 0, 0, $w, $h);
	}
	print ";";
}

sub put_anime_frame {
	local (*VALS, $sx, $sy, $w, $h) = @_;

	local ($delay);
	local ($i);

	$delay = 0;
	for ($i = 0; $i < @VALS; $i++) {
		if ($i == $#VALS) {
			$delay = 10;
		}
		&put_oneimg_block(
			$VALS[$i],
			$sx + ($w * $i),
			$sy,
			$w,
			$h,
			$delay
		);
	}
}

sub put_oneimg_block {
	local ($index, $sx, $sy, $w, $h, $delay) = @_;

	local (@PAL);
	local (@BITMAP);

	@PAL = &get_dies_palette($index);
	@BITMAP = &get_dies_bitmap($index);

	if ($index == 0) {
		&put_extend_info($delay, 1, 1, 2);
	} elsif ($index == 1) {
		&put_extend_info($delay, 1, 1, 4);
	} else {
		&put_extend_info($delay, 1, 1, 3);
	}
	&put_image_info($sx, $sy, $w, $h, 0, 1);
	&put_palette_blk(*PAL);
	&put_image_blk(*BITMAP);
}

sub put_header_blk {
	local ($bg_index, $w, $h) = @_;

	local ($hdr);

	$hdr  = 'GIF89a';				# Signature
	$hdr .= pack("SS", $w, $h);		# Logical Screen Width Height
#	$hdr .= pack("C", 0xF7);		# 8bit
#	$hdr .= pack("C", 0xA3);		# 4bit
	$hdr .= pack("C", 0xA2);		# 3bit
	# 1111 0111b
	# |||| |+++- Size of Global Color Table
	# |||| +---- Color Table Sort Flag
	# |+++------ Color Resolution
	# +--------- Global Color Table Flag
	$hdr .= pack("C", $bg_index);
	$hdr .= pack("C", 0);

	print $hdr;
}

sub put_palette_blk {
	local (*PAL) = @_;

	local ($pal);
	local ($i);

	$pal = '';
	for ($i = 0; $i < 8; $i++) {
		$pal .= pack("C", $PAL[$i*3]);
		$pal .= pack("C", $PAL[$i*3+1]);
		$pal .= pack("C", $PAL[$i*3+2]);
	}
	print $pal;
}

sub put_apl_blk_loop {
	local ($loop) = @_;

	local ($blk);

	$blk  = '!';	# extend info
	$blk .= pack("C", 0xFF);
	$blk .= pack("C", 11);
	$blk .= 'NETSCAPE';		# 8
	$blk .= '2.0';			# 3
	$blk .= pack("C", 0x03);
	$blk .= pack("C", 0x01);
	$blk .= pack("S", $loop);
	$blk .= pack("C", 0);

	print $blk;

}

sub put_extend_comment {
	local ($text) = @_;

	local ($blk);

	$blk  = '!';	# extend info
	$blk .= pack("C", 0xFE);
	$blk .= pack("C", length($text) + 1);
	$blk .= $text;
	$blk .= pack("C", 0);
	$blk .= pack("C", 0);

	print $blk;
}

sub put_extend_info {
	local ($delay, $disposal, $use, $tindex) = @_;

	local ($blk);
	local ($flag);

	$blk  = '!';	# extend info
	$blk .= pack("CC", 0xF9, 4);
	$disposal &= 0x07;
	$flag  = $disposal << 2;
	$use &= 0x01;
	$flag |= $use;
	$blk .= pack("C", $flag);
	# 0000 0001b
	#    | |||+- Transparent Color Flag
	#    | ||+-- User Input Flag
	#    +-++--- Disposal Method
	$blk .= pack("S", $delay);			# delay
	if ($use != 0) {
		$blk .= pack("CC", $tindex, 0);		# transpearent index, EOB
	} else {
		$blk .= pack("CC", 0, 0);		# transpearent index, EOB
	}

	print $blk;
}

sub put_image_info {
	local ($sx, $sy, $w, $h, $use_interlace, $use_local_color) = @_;

	local ($blk);
	local ($flag);

	$blk  = ',';
	$blk .= pack("S", $sx);
	$blk .= pack("S", $sy);
	$blk .= pack("S", $w);
	$blk .= pack("S", $h);

	$flag = 0x00;
	if ($use_local_color == 1) {
		$flag = 0x82;
	}
	if ($use_interlace == 1) {
		$flag |= 0x40;
	}

	$blk .= pack("C", $flag);	# interlace = 0x40 non = 0x00
	# 1000 0011b
	# |||   +++- Size of Local Color Table
	# ||+------- Color Table Sort Flag
	# |+-------- Interlace Flag
	# +--------- Local Color Table Flag

	print $blk;
}

sub put_image_blk {
	local (*DATA) = @_;

	local ($i);

	for ($i = 0; $i < @DATA; $i++) {
		print pack("C", $DATA[$i]);
	}
}

sub put_end_of_gif {

	print ';';	# END OF GIF
}

sub flush_block {

	print pack("C", $inblk);
	print $blkbuf;
	$blkbuf = '';
	$inblk = 0;
}

sub put_block {
	local ($c) = @_;

	$blkbuf .= pack("C", $c);
	$inblk++;
	if ($inblk >= 255) {
		&flush_block;
	}
}

sub put_bits_raw {
	local ($c, $bits) = @_;

	$bitbuf |= $c << $inbit;
	$inbit += $bits;
	while ($inbit >= 8) {
		&put_block($bitbuf & 0x00FF);
		$bitbuf >>= 8;
		$inbit -= 8;
	}
}

sub put_bits {
	local ($c, $bits) = @_;

	if ($putcount >= $bits_limit) {
		&put_bits_raw($clear_code, $bits);
		$putcount = 0;
	}
	&put_bits_raw($c, $bits);
	$putcount++;
}

sub init_bits {

	$bitbuf = 0;
	$inblk = 0;
	$inbit = 0;
	$putcount = 1;
}

sub get_dies_palette {
	local ($index) = @_;

@PAL0 = (
0xFF,0xFF,0xFF,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xDF,0x00,0x29,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
@PAL1 = (
0xFF,0xFF,0xFF,0x00,0x00,0x00,0xFF,0x00,0x00,0xDF,0x00,0x29,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
@PAL2 = (
0xFF,0xFF,0xFF,0x00,0x00,0x00,0x80,0x80,0x80,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);

	if ($index == 1) {
		return @PAL1;
	} elsif ($index == 2) {
		return @PAL2;
	} elsif ($index == 3) {
		return @PAL2;
	} elsif ($index == 4) {
		return @PAL2;
	} elsif ($index == 5) {
		return @PAL2;
	} elsif ($index == 6) {
		return @PAL2;
	}
	return @PAL0;
}

sub get_dies_bitmap {
	local ($index) = @_;

@BITMAP0 = (
0x02,0x25,0x94,0x82,0xA9,0x68,0x07,0x0F,0xE3,0x0B,0x4E,0xDA,0x19,0xEE,0x45,0xDA,
0xF2,0x1E,0x7D,0x20,0x36,0x42,0xE2,0x78,0x82,0x69,0xB7,0x6A,0xED,0x96,0x95,0x00,
0x15,0xAB,0xCD,0x82,0x53,0x42,0x01,0x00);

@BITMAP1 = (
0x03,0x30,0x48,0x14,0xDC,0xCE,0x6A,0x81,0x49,0xEB,0x0C,0xD2,0xEA,0x1B,0xF6,0x66,
0x9E,0x06,0x86,0xD5,0x58,0x0D,0x83,0xD8,0x9D,0x83,0x20,0x58,0xE6,0xD4,0x02,0x6F,
0xB9,0x56,0xAE,0x4A,0xDA,0x3B,0x15,0x93,0xBF,0x10,0xE6,0x26,0x8C,0x3C,0x8E,0x18,
0x42,0x02,0x00);

@BITMAP2 = (
0x02,0x2A,0xDC,0x82,0xA9,0x68,0x07,0x0F,0xE3,0x0B,0x4E,0xDA,0x19,0xEE,0x45,0x90,
0x6B,0x0F,0x04,0x82,0x16,0x66,0x64,0x04,0x9E,0xA5,0xDA,0x99,0x6C,0x2A,0x81,0x30,
0x3A,0x62,0xAC,0x7D,0x53,0x2E,0x49,0x19,0xCB,0xDF,0x2B,0x00,0x00);


@BITMAP3 = (
0x02,0x2B,0xDC,0x82,0xA9,0x68,0x07,0x0F,0xE3,0x0B,0x4E,0xDA,0x19,0xEE,0x45,0x90,
0x6B,0x0F,0x04,0x82,0x16,0x66,0x64,0x04,0x76,0x26,0xBA,0x76,0xA3,0x94,0x9E,0x31,
0xAB,0x92,0x62,0x7D,0xE2,0x79,0x58,0xC9,0xCD,0x02,0xA4,0x0C,0x0A,0x00);


@BITMAP4 = (
0x02,0x2D,0xDC,0x82,0xA9,0x68,0x07,0x0F,0xE3,0x0B,0x4E,0xDA,0x19,0xEE,0x45,0x90,
0xF7,0x8C,0x75,0x42,0x14,0x8C,0xA1,0x26,0x79,0xE8,0xB7,0x92,0x60,0x0B,0xA8,0x6A,
0xFC,0xCA,0xE6,0x74,0xCF,0xAB,0x8E,0x52,0x6F,0xDF,0x58,0x08,0x29,0x83,0x02,0x00);

@BITMAP5 = (
0x02,0x2E,0xDC,0x82,0xA9,0x68,0x07,0x0F,0xE3,0x0B,0x4E,0xDA,0x19,0xEE,0x45,0x90,
0xF7,0x8C,0x75,0x42,0x14,0x8C,0xA1,0x26,0x79,0x24,0xB8,0x5A,0xA5,0xCB,0xA2,0x27,
0xA0,0xD2,0xAC,0xFA,0x8A,0x9F,0xDC,0xF2,0x53,0x25,0xA3,0x18,0x16,0x44,0x61,0x01,0x00
);


@BITMAP6 = (
0x02,0x2E,0xDC,0x82,0xA9,0x68,0x07,0x0F,0xE3,0x0B,0x4E,0xDA,0x19,0x20,0x8A,0x1B,
0x6B,0xC1,0x81,0xDE,0x65,0x75,0x24,0x97,0x8D,0xAA,0x19,0x88,0x93,0x6B,0x9E,0xAA,
0x0C,0xB0,0xE9,0x7A,0xB7,0xA1,0x76,0xD3,0x54,0x4F,0xA2,0x18,0x16,0x44,0x61,0x01,0x00
);

	if ($index == 1) {
		return @BITMAP1;
	} elsif ($index == 2) {
		return @BITMAP2;
	} elsif ($index == 3) {
		return @BITMAP3;
	} elsif ($index == 4) {
		return @BITMAP4;
	} elsif ($index == 5) {
		return @BITMAP5;
	} elsif ($index == 6) {
		return @BITMAP6;
	}
	return @BITMAP0;
}

sub random_seed {
	local ($s) = @_;

	if ($use_org_random != 0) {
		if ($s eq '') {
			&org_random_seed('');
		} else {
			&org_random_seed($s);
		}
		return;
	}

	if ($s eq '') {
		eval {
			srand();
		};
		if ($@) {
			&org_random_seed('');
		}
	} else {
		eval {
			srand($s);
		};
		if ($@) {
			&org_random_seed($s);
		}
	}
}

sub get_random_value {
	local ($range) = @_;

	local ($r);

	if ($use_org_random != 0) {
		$r = &org_random($range);
		return $r;
	}

	eval {
		$r = int(rand($range));
	};
	if ($@) {
		$r = &org_random($range);
	}
	return $r;
}

sub org_random_seed {
	local ($s) = @_;

	if ($s eq '') {
		$org_seed1 = time;
		$org_seed1 &= 0xFFFF;
		$org_seed2 = time * 259;
		$org_seed2 &= 0xFFFF;
	} else {
		$org_seed1 = $s;
		$org_seed1 &= 0xFFFF;
		$org_seed2 = $s * 259;
		$org_seed2 &= 0xFFFF;
	}
}

sub org_random {
	local ($range) = @_;

	local ($r);

	$r = &_org_random;
	$r <<= 16;
	$r |= &_org_random;

	eval {
		$r = int($r % $range);
	};
	if ($@) {
		return 0;
	}
	return $r;
}

sub _org_random {

	local ($r);
	local ($t);

	$t = $org_seed2;
	$org_seed2 = $org_seed1 + $org_seed2;
	$org_seed1 = $t;
	$org_seed2 += 0x3711;
	$org_seed2 &= 0x0000FFFF;
	$r = $org_seed2;

	return $r;
}

__END__
